--- u-boot-2011.06_original/arch/arm/cpu/armv7/cnc1900/Makefile	1970-01-01 08:00:00.000000000 +0800
+++ u-boot-2011.06/arch/arm/cpu/armv7/cnc1900/Makefile	2014-07-29 17:28:38.819972000 +0800
@@ -0,0 +1,46 @@
+#
+# (C) Copyright 2000-2006
+# Wolfgang Denk, DENX Software Engineering, wd@denx.de.
+#
+# See file CREDITS for list of people who contributed to this
+# project.
+#
+# This program is free software; you can redistribute it and/or
+# modify it under the terms of the GNU General Public License as
+# published by the Free Software Foundation; either version 2 of
+# the License, or (at your option) any later version.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write to the Free Software
+# Foundation, Inc., 59 Temple Place, Suite 330, Boston,
+# MA 02111-1307 USA
+#
+
+include $(TOPDIR)/config.mk
+
+LIB	= $(obj)lib$(SOC).o
+
+COBJS	= timer.o soc.o interrupts.o
+SOBJS	= reset.o
+
+SRCS	:= $(SOBJS:.o=.S) $(COBJS:.o=.c)
+OBJS	:= $(addprefix $(obj),$(COBJS)) $(addprefix $(obj),$(SOBJS))
+
+all:	$(obj).depend $(LIB)
+
+$(LIB):	$(OBJS)
+	$(call cmd_link_o_target, $(OBJS))
+
+#########################################################################
+
+# defines $(obj).depend target
+include $(SRCTREE)/rules.mk
+
+sinclude $(obj).depend
+
+#########################################################################
diff '--exclude=.svn' -Naur u-boot-2011.06_original/arch/arm/cpu/armv7/cnc1900/reset.S u-boot-2011.06/arch/arm/cpu/armv7/cnc1900/reset.S
--- u-boot-2011.06_original/arch/arm/cpu/armv7/cnc1900/reset.S	1970-01-01 08:00:00.000000000 +0800
+++ u-boot-2011.06/arch/arm/cpu/armv7/cnc1900/reset.S	2014-07-29 17:28:38.819972000 +0800
@@ -0,0 +1,19 @@
+#include <config.h>
+/*
+ * Processor reset for CNC1900
+ */
+
+	.align 5
+.globl reset_cpu
+reset_cpu:
+	ldr  r1, WDT_BASE
+	mov  r2, #9
+	str r2, [r1, #0x28]        /* WDT_CR, enable WDT and generated System Reset */
+	mov  r2, #1
+	str r2, [r1, #0x20]        /* WDT_TORR, minimum value */
+
+_loop_forever:
+	b	_loop_forever
+
+WDT_BASE:
+	.word   0x80020600
diff '--exclude=.svn' -Naur u-boot-2011.06_original/arch/arm/cpu/armv7/cnc1900/soc.c u-boot-2011.06/arch/arm/cpu/armv7/cnc1900/soc.c
--- u-boot-2011.06_original/arch/arm/cpu/armv7/cnc1900/soc.c	1970-01-01 08:00:00.000000000 +0800
+++ u-boot-2011.06/arch/arm/cpu/armv7/cnc1900/soc.c	2014-07-29 17:28:38.819972000 +0800
@@ -0,0 +1,24 @@
+#include <common.h>
+#include <errno.h>
+
+/*
+ * Initializes on-chip ethernet controllers.
+ * to override, implement board_eth_init()
+ */
+
+#if defined(CONFIG_DRIVER_CN100)
+extern int cn100_initialize(bd_t *bis, int index);
+#endif
+
+int cpu_eth_init(bd_t *bis)
+{
+	int rc = -ENODEV;
+#if defined(CONFIG_DRIVER_CN100)
+	rc = cn100_initialize(bis, 0);
+#if defined(CONFIG_DRIVER_CN100_MULTI)
+	rc = cn100_initialize(bis, 1);
+#endif
+#endif
+	return rc;
+}
+
diff '--exclude=.svn' -Naur u-boot-2011.06_original/arch/arm/cpu/armv7/cnc1900/timer.c u-boot-2011.06/arch/arm/cpu/armv7/cnc1900/timer.c
--- u-boot-2011.06_original/arch/arm/cpu/armv7/cnc1900/timer.c	1970-01-01 08:00:00.000000000 +0800
+++ u-boot-2011.06/arch/arm/cpu/armv7/cnc1900/timer.c	2014-07-29 17:28:38.819972000 +0800
@@ -0,0 +1,129 @@
+/*
+ * (C) Copyright 2012
+ * Xiaodong Fan <xiaodong.fan@cavium.com>
+ *
+ * See file CREDITS for list of people who contributed to this
+ * project.
+ *
+ * This program is free software; you can redistribute it and/or
+ * modify it under the terms of the GNU General Public License as
+ * published by the Free Software Foundation; either version 2 of
+ * the License, or (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston,
+ * MA 02111-1307 USA
+ */
+
+#include <common.h>
+#include <div64.h>
+#include <asm/io.h>
+
+DECLARE_GLOBAL_DATA_PTR;
+
+#define CONFIG_SYS_CPU_TWD	0x80020600
+
+#define TWD_TIMER_LOAD			(CONFIG_SYS_CPU_TWD + 0x00)
+#define TWD_TIMER_COUNTER		(CONFIG_SYS_CPU_TWD + 0x04)
+#define TWD_TIMER_CONTROL		(CONFIG_SYS_CPU_TWD + 0x08)
+#define TWD_TIMER_INTSTAT		(CONFIG_SYS_CPU_TWD + 0x0C)
+
+#define TIMER_LOAD_VAL 0xffffffff
+
+/* macro to read the decrementing 32 bit timer as an increasing count */
+#define READ_TIMER()  ((ulong)((ulong)TIMER_LOAD_VAL - __raw_readl(TWD_TIMER_COUNTER)))
+
+#define HW_REG_READ( ByteAddr )      (*(volatile unsigned int*)(ByteAddr))
+
+unsigned int get_timer_freq(void)
+{
+	unsigned int timer_rate_hz;
+	unsigned int pll_cpu_div_f, pll_cpu_div_q;
+	
+	pll_cpu_div_f = (HW_REG_READ(0xb2100318) >> 6) & 0x7f;
+	pll_cpu_div_q = (HW_REG_READ(0xb2100318) >> 3) & 0x7;	
+	timer_rate_hz = ((pll_cpu_div_f + 1) / pll_cpu_div_q * 27000000)>>1;
+
+	return timer_rate_hz;
+}
+
+static inline unsigned long long tick_to_time(unsigned long long tick)
+{
+	unsigned int tmp;
+	tmp=gd->timer_rate_hz/CONFIG_SYS_HZ;
+
+	do_div(tick, tmp);
+
+	return tick;
+}
+
+unsigned long long usec_to_tick(unsigned long long usec)
+{
+	unsigned int tmp;
+	tmp=gd->timer_rate_hz/1000000;
+	usec *= tmp;
+
+	return usec;
+}
+
+int timer_init(void)
+{
+	__raw_writel(TIMER_LOAD_VAL, TWD_TIMER_LOAD);
+	__raw_writel(0x03, TWD_TIMER_CONTROL);
+
+  gd->timer_rate_hz = get_timer_freq();
+  gd->tbu = gd->tbl = 0;
+
+	return 0;
+}
+
+/*
+ * Get the current 64 bit timer tick count
+ */
+unsigned long long get_ticks(void)
+{
+	ulong now = READ_TIMER();
+
+	/* increment tbu if tbl has rolled over */
+	if (now < gd->tbl)
+		gd->tbu++;
+	gd->tbl = now;
+
+	return (((unsigned long long)gd->tbu) << 32) | gd->tbl;
+}
+
+void __udelay(unsigned long usec)
+{
+	unsigned long long start;
+	ulong tmo;
+
+	start = get_ticks();		/* get current timestamp */
+	tmo = usec_to_tick(usec);	/* convert usecs to ticks */
+	while ((get_ticks() - start) < tmo)
+		;			/* loop till time has passed */
+}
+
+/* msecs	*/
+ulong get_timer(ulong base)
+{
+	ulong current_time = tick_to_time(get_ticks());
+
+	return current_time - base;
+}
+
+/*
+ * Return the number of timer ticks per second.
+ */
+ulong get_tbclk(void)
+{
+	return gd->timer_rate_hz;
+}
+
+
+
diff '--exclude=.svn' -Naur u-boot-2011.06_original/arch/arm/cpu/armv7/cpu.c u-boot-2011.06/arch/arm/cpu/armv7/cpu.c
--- u-boot-2011.06_original/arch/arm/cpu/armv7/cpu.c	2011-06-28 04:22:42.000000000 +0800
+++ u-boot-2011.06/arch/arm/cpu/armv7/cpu.c	2014-07-29 17:28:38.819972000 +0800
@@ -39,6 +39,8 @@
 #include <asm/arch/sys_proto.h>
 #endif
 
+extern void invalidate_dcache(void);
+
 static void cache_flush(void);
 
 int cleanup_before_linux(void)
@@ -59,7 +61,7 @@
 
 	/* invalidate I-cache */
 	cache_flush();
-
+	invalidate_dcache();
 #ifndef CONFIG_L2_OFF
 	/* turn off L2 cache */
 	l2_cache_disable();
diff '--exclude=.svn' -Naur u-boot-2011.06_original/arch/arm/cpu/armv7/Makefile u-boot-2011.06/arch/arm/cpu/armv7/Makefile
--- u-boot-2011.06_original/arch/arm/cpu/armv7/Makefile	2011-06-28 04:22:42.000000000 +0800
+++ u-boot-2011.06/arch/arm/cpu/armv7/Makefile	2014-07-29 17:28:38.819972000 +0800
@@ -28,6 +28,7 @@
 START	:= start.o
 COBJS	:= cpu.o
 COBJS  += syslib.o
+COBJS	+= cache_v7.o
 
 SRCS	:= $(START:.o=.S) $(COBJS:.o=.c)
 OBJS	:= $(addprefix $(obj),$(COBJS))
diff '--exclude=.svn' -Naur u-boot-2011.06_original/arch/arm/cpu/armv7/s5p-common/timer.c u-boot-2011.06/arch/arm/cpu/armv7/s5p-common/timer.c
--- u-boot-2011.06_original/arch/arm/cpu/armv7/start.S	2011-06-28 04:22:42.000000000 +0800
+++ u-boot-2011.06/arch/arm/cpu/armv7/start.S	2014-10-27 11:54:35.916774000 +0800
@@ -50,7 +50,11 @@
 _not_used:		.word not_used
 _irq:			.word irq
 _fiq:			.word fiq
+#ifdef UBOOT_VERSIONTAG
+_pad:			.word (0x12345678 + (UBOOT_VERSIONTAG << 24)) 
+#else
 _pad:			.word 0x12345678 /* now 16*4=64 */
+#endif
 .global _end_vect
 _end_vect:
 
@@ -98,6 +102,11 @@
 	.word _end - _start
 
 #ifdef CONFIG_USE_IRQ
+
+/* IRQ stack memory (calculated at run-time) + 8 bytes */
+.globl IRQ_STACK_START_IN
+IRQ_STACK_START_IN:
+	.word	0x0badc0de
 /* IRQ stack memory (calculated at run-time) */
 .globl IRQ_STACK_START
 IRQ_STACK_START:
@@ -109,10 +118,6 @@
 	.word 0x0badc0de
 #endif
 
-/* IRQ stack memory (calculated at run-time) + 8 bytes */
-.globl IRQ_STACK_START_IN
-IRQ_STACK_START_IN:
-	.word	0x0badc0de
 
 /*
  * the actual reset code
@@ -155,6 +160,23 @@
 	bl	cpu_init_crit
 #endif
 
+        /* 
+         * The PIC(Position Independent Code) codes such as hdmi or OTA are occupying the BSS segment,
+         * move them behind the BSS segment.
+         */
+        adr r3, _start
+        ldr r0, _end_ofs
+        add r0, r0, r3        /* now r0 is equal _end */
+        ldr r1, _bss_end_ofs
+        add r1, r1, r3        /* now r1 is equal __bss_end__ */
+        ldr r2, =(CONFIG_UBOOT_EXTERNAL_PROC_LEN)
+        add r2, r0, r2
+mov_PIC_codes:
+        ldmia   r0!, {r3-r10}           /* copy from source address [r0]    */
+        stmia   r1!, {r3-r10}           /* copy to   target address [r1]    */
+        cmp     r0, r2                  /* until source end address [r2]    */
+        blo     mov_PIC_codes
+
 /* Set stackpointer in internal RAM to call board_init_f */
 call_board_init_f:
 	ldr	sp, =(CONFIG_SYS_INIT_SP_ADDR)
@@ -498,4 +520,4 @@
 	bad_save_user_regs
 	bl	do_fiq
 
-#endif
+#endif/*CONFIG_USE_IRQ*/
diff '--exclude=.svn' -Naur u-boot-2011.06_original/arch/arm/cpu/armv7/tegra2/board.c u-boot-2011.06/arch/arm/cpu/armv7/tegra2/board.c
--- u-boot-2011.06_original/arch/arm/cpu/armv7/tegra2/board.c	2011-06-28 04:22:42.000000000 +0800
+++ u-boot-2011.06/arch/arm/cpu/armv7/tegra2/board.c	2014-07-29 17:28:38.819972000 +0800
@@ -1,4 +1,4 @@
-/*
+_*
  *  (C) Copyright 2010,2011
  *  NVIDIA Corporation <www.nvidia.com>
  *
diff '--exclude=.svn' -Naur u-boot-2011.06_original/arch/arm/include/asm/arch-cnc1900/sys_proto.h u-boot-2011.06/arch/arm/include/asm/arch-cnc1900/sys_proto.h
--- u-boot-2011.06_original/arch/arm/include/asm/arch-cnc1900/sys_proto.h	1970-01-01 08:00:00.000000000 +0800
+++ u-boot-2011.06/arch/arm/include/asm/arch-cnc1900/sys_proto.h	2014-07-29 17:28:38.819972000 +0800
@@ -0,0 +1,30 @@
+/*
+ * (C) Copyright 2011 Cavium Inc.
+ * Xiaodong Fan <xiaodong.fan@caviumnetworks.com>
+ *
+ * See file CREDITS for list of people who contributed to this
+ * project.
+ *
+ * This program is free software; you can redistribute it and/or
+ * modify it under the terms of the GNU General Public License as
+ * published by the Free Software Foundation; either version 2 of
+ * the License, or (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston,
+ * MA 02111-1307 USA
+ */
+
+#ifndef _CNC1900_SYS_PROTO_H
+#define _CNC1900_SYS_PROTO_H
+
+void invalidate_dcache(void);
+
+#endif 
+
diff '--exclude=.svn' -Naur u-boot-2011.06_original/arch/arm/include/asm/arch-csm1800h/gpio.h u-boot-2011.06/arch/arm/include/asm/arch-csm1800h/gpio.h
--- u-boot-2011.06_original/arch/arm/include/asm/arch-csm1800h/gpio.h	1970-01-01 08:00:00.000000000 +0800
+++ u-boot-2011.06/arch/arm/include/asm/arch-csm1800h/gpio.h	2014-07-29 17:28:38.819972000 +0800
@@ -0,0 +1,42 @@
+/*
+ * (C) Copyright 2009 Alessandro Rubini
+ *
+ * See file CREDITS for list of people who contributed to this
+ * project.
+ *
+ * This program is free software; you can redistribute it and/or
+ * modify it under the terms of the GNU General Public License as
+ * published by the Free Software Foundation; either version 2 of
+ * the License, or (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston,
+ * MA 02111-1307 USA
+ */
+#ifndef __NMK_GPIO_H__
+#define __NMK_GPIO_H__
+
+/*
+ * These functions are called from the soft-i2c driver, but
+ * are also used by board files to set output bits.
+ */
+
+enum nmk_af { /* alternate function settings */
+	GPIO_GPIO = 0,
+	GPIO_ALT_A,
+	GPIO_ALT_B,
+	GPIO_ALT_C
+};
+
+extern void nmk_gpio_af(int gpio, int alternate_function);
+extern void nmk_gpio_dir(int gpio, int dir);
+extern void nmk_gpio_set(int gpio, int val);
+extern int nmk_gpio_get(int gpio);
+
+#endif /* __NMK_GPIO_H__ */
diff '--exclude=.svn' -Naur u-boot-2011.06_original/arch/arm/include/asm/arch-csm1800h/hardware.1 u-boot-2011.06/arch/arm/include/asm/arch-csm1800h/hardware.1
--- u-boot-2011.06_original/arch/arm/include/asm/arch-tegra2/sys_proto.h	2011-06-28 04:22:42.000000000 +0800
+++ u-boot-2011.06/arch/arm/include/asm/arch-tegra2/sys_proto.h	2014-07-29 17:28:38.819972000 +0800
@@ -30,6 +30,6 @@
 
 void invalidate_dcache(void);
 
-extern const struct tegra2_sysinfo sysinfo;
+extern const struct tegra1_sysinfo sysinfo;
 
 #endif
diff '--exclude=.svn' -Naur u-boot-2011.06_original/arch/arm/include/asm/armv7.h u-boot-2011.06/arch/arm/include/asm/armv7.h
--- u-boot-2011.06_original/arch/arm/include/asm/armv7.h	1970-01-01 08:00:00.000000000 +0800
+++ u-boot-2011.06/arch/arm/include/asm/armv7.h	2014-07-29 17:28:38.819972000 +0800
@@ -0,0 +1,92 @@
+/*
+ * (C) Copyright 2010
+ * Texas Instruments, <www.ti.com>
+ * Aneesh V <aneesh@ti.com>
+ *
+ * SPDX-License-Identifier:	GPL-2.0+
+ */
+#ifndef ARMV7_H
+#define ARMV7_H
+
+/* Cortex-A9 revisions */
+#define MIDR_CORTEX_A9_R0P1	0x410FC091
+#define MIDR_CORTEX_A9_R1P2	0x411FC092
+#define MIDR_CORTEX_A9_R1P3	0x411FC093
+#define MIDR_CORTEX_A9_R2P10	0x412FC09A
+
+/* Cortex-A15 revisions */
+#define MIDR_CORTEX_A15_R0P0	0x410FC0F0
+#define MIDR_CORTEX_A15_R2P2	0x412FC0F2
+
+/* Cortex-A7 revisions */
+#define MIDR_CORTEX_A7_R0P0	0x410FC070
+
+#define MIDR_PRIMARY_PART_MASK	0xFF0FFFF0
+
+/* ID_PFR1 feature fields */
+#define CPUID_ARM_SEC_SHIFT		4
+#define CPUID_ARM_SEC_MASK		(0xF << CPUID_ARM_SEC_SHIFT)
+#define CPUID_ARM_VIRT_SHIFT		12
+#define CPUID_ARM_VIRT_MASK		(0xF << CPUID_ARM_VIRT_SHIFT)
+#define CPUID_ARM_GENTIMER_SHIFT	16
+#define CPUID_ARM_GENTIMER_MASK		(0xF << CPUID_ARM_GENTIMER_SHIFT)
+
+/* valid bits in CBAR register / PERIPHBASE value */
+#define CBAR_MASK			0xFFFF8000
+
+/* CCSIDR */
+#define CCSIDR_LINE_SIZE_OFFSET		0
+#define CCSIDR_LINE_SIZE_MASK		0x7
+#define CCSIDR_ASSOCIATIVITY_OFFSET	3
+#define CCSIDR_ASSOCIATIVITY_MASK	(0x3FF << 3)
+#define CCSIDR_NUM_SETS_OFFSET		13
+#define CCSIDR_NUM_SETS_MASK		(0x7FFF << 13)
+
+/*
+ * Values for InD field in CSSELR
+ * Selects the type of cache
+ */
+#define ARMV7_CSSELR_IND_DATA_UNIFIED	0
+#define ARMV7_CSSELR_IND_INSTRUCTION	1
+
+/* Values for Ctype fields in CLIDR */
+#define ARMV7_CLIDR_CTYPE_NO_CACHE		0
+#define ARMV7_CLIDR_CTYPE_INSTRUCTION_ONLY	1
+#define ARMV7_CLIDR_CTYPE_DATA_ONLY		2
+#define ARMV7_CLIDR_CTYPE_INSTRUCTION_DATA	3
+#define ARMV7_CLIDR_CTYPE_UNIFIED		4
+
+#ifndef __ASSEMBLY__
+#include <linux/types.h>
+
+/*
+ * CP15 Barrier instructions
+ * Please note that we have separate barrier instructions in ARMv7
+ * However, we use the CP15 based instructtions because we use
+ * -march=armv5 in U-Boot
+ */
+#define CP15ISB	asm volatile ("mcr     p15, 0, %0, c7, c5, 4" : : "r" (0))
+#define CP15DSB	asm volatile ("mcr     p15, 0, %0, c7, c10, 4" : : "r" (0))
+#define CP15DMB	asm volatile ("mcr     p15, 0, %0, c7, c10, 5" : : "r" (0))
+
+void v7_outer_cache_enable(void);
+void v7_outer_cache_disable(void);
+void v7_outer_cache_flush_all(void);
+void v7_outer_cache_inval_all(void);
+void v7_outer_cache_flush_range(u32 start, u32 end);
+void v7_outer_cache_inval_range(u32 start, u32 end);
+
+#if defined(CONFIG_ARMV7_NONSEC) || defined(CONFIG_ARMV7_VIRT)
+
+int armv7_switch_nonsec(void);
+int armv7_switch_hyp(void);
+
+/* defined in assembly file */
+unsigned int _nonsec_init(void);
+void _smp_pen(void);
+void _switch_to_hyp(void);
+#endif /* CONFIG_ARMV7_NONSEC || CONFIG_ARMV7_VIRT */
+
+#endif /* ! __ASSEMBLY__ */
+
+#endif
diff '--exclude=.svn' -Naur u-boot-2011.06_original/arch/arm/include/asm/cache.h u-boot-2011.06/arch/arm/include/asm/cache.h
--- u-boot-2011.06_original/arch/arm/include/asm/cache.h	2011-06-28 04:22:42.000000000 +0800
+++ u-boot-2011.06/arch/arm/include/asm/cache.h	2014-07-29 17:28:38.819972000 +0800
@@ -42,4 +42,15 @@
 void l2_cache_enable(void);
 void l2_cache_disable(void);
 
+/*
+ * The current upper bound for ARM L1 data cache line sizes is 64 bytes.  We
+ * use that value for aligning DMA buffers unless the board config has specified
+ * an alternate cache line size.
+ */
+#ifdef CONFIG_SYS_CACHELINE_SIZE
+#define ARCH_DMA_MINALIGN	CONFIG_SYS_CACHELINE_SIZE
+#else
+#define ARCH_DMA_MINALIGN	64
+#endif
+
 #endif /* _ASM_CACHE_H */
diff '--exclude=.svn' -Naur u-boot-2011.06_original/arch/arm/include/asm/global_data.h u-boot-2011.06/arch/arm/include/asm/global_data.h
--- u-boot-2011.06_original/arch/arm/include/asm/global_data.h	2011-06-28 04:22:42.000000000 +0800
+++ u-boot-2011.06/arch/arm/include/asm/global_data.h	2014-11-19 00:41:17.367468000 +0800
@@ -73,6 +73,20 @@
 #if !(defined(CONFIG_SYS_NO_ICACHE) && defined(CONFIG_SYS_NO_DCACHE))
 	unsigned long	tlb_addr;
 #endif
+
+#if defined(CONFIG_SPI_FLASH_CNC1800L) || defined(CONFIG_SPI_FLASH_CNC1900)
+	sfinf_t 	*sf_inf;
+	unsigned char 	sf_alen;
+	unsigned char 	sf_boot;
+	unsigned 	sf_rspd;
+	unsigned 	sf_wspd;
+	unsigned 	sf_size;
+#endif
+#ifdef CONFIG_ARCH_CNC1900
+	unsigned int cpu_freq;
+	unsigned int ddr_freq;
+	int uart_locked;
+#endif
 	void		**jt;		/* jump table */
 	char		env_buf[32];	/* buffer for getenv() before reloc. */
 } gd_t;
diff '--exclude=.svn' -Naur u-boot-2011.06_original/arch/arm/include/asm/io.h u-boot-2011.06/arch/arm/include/asm/io.h
--- u-boot-2011.06_original/arch/arm/include/asm/io.h	2011-06-28 04:22:42.000000000 +0800
+++ u-boot-2011.06/arch/arm/include/asm/io.h	2014-07-29 17:28:38.819972000 +0800
@@ -75,7 +75,7 @@
 #define __arch_putw(v,a)		(*(volatile unsigned short *)(a) = (v))
 #define __arch_putl(v,a)		(*(volatile unsigned int *)(a) = (v))
 
-extern inline void __raw_writesb(unsigned int addr, const void *data, int bytelen)
+static inline void __raw_writesb(unsigned int addr, const void *data, int bytelen)
 {
 	uint8_t *buf = (uint8_t *)data;
 	while(bytelen--)
@@ -89,14 +89,14 @@
 		__arch_putw(*buf++, addr);
 }
 
-extern inline void __raw_writesl(unsigned int addr, const void *data, int longlen)
+static inline void __raw_writesl(unsigned int addr, const void *data, int longlen)
 {
 	uint32_t *buf = (uint32_t *)data;
 	while(longlen--)
 		__arch_putl(*buf++, addr);
 }
 
-extern inline void __raw_readsb(unsigned int addr, void *data, int bytelen)
+static inline void __raw_readsb(unsigned int addr, void *data, int bytelen)
 {
 	uint8_t *buf = (uint8_t *)data;
 	while(bytelen--)
@@ -110,7 +110,7 @@
 		*buf++ = __arch_getw(addr);
 }
 
-extern inline void __raw_readsl(unsigned int addr, void *data, int longlen)
+static inline void __raw_readsl(unsigned int addr, void *data, int longlen)
 {
 	uint32_t *buf = (uint32_t *)data;
 	while(longlen--)
diff '--exclude=.svn' -Naur u-boot-2011.06_original/arch/arm/include/asm/system.h u-boot-2011.06/arch/arm/include/asm/system.h
--- u-boot-2011.06_original/arch/arm/include/asm/system.h	2011-06-28 04:22:42.000000000 +0800
+++ u-boot-2011.06/arch/arm/include/asm/system.h	2014-07-29 17:28:38.819972000 +0800
@@ -61,6 +61,12 @@
 
 #define nop() __asm__ __volatile__("mov\tr0,r0\t@ nop\n\t");
 
+#ifdef __ARM_ARCH_7A__
+#define wfi() __asm__ __volatile__ ("wfi" : : : "memory")
+#else
+#define wfi()
+#endif
+
 static inline unsigned int get_cr(void)
 {
 	unsigned int val;
@@ -75,6 +81,51 @@
 	isb();
 }
 
+static inline unsigned int get_dacr(void)
+{
+	unsigned int val;
+	asm("mrc p15, 0, %0, c3, c0, 0	@ get DACR" : "=r" (val) : : "cc");
+	return val;
+}
+
+static inline void set_dacr(unsigned int val)
+{
+	asm volatile("mcr p15, 0, %0, c3, c0, 0	@ set DACR"
+	  : : "r" (val) : "cc");
+	isb();
+}
+
+/* options available for data cache on each page */
+enum dcache_option {
+	DCACHE_OFF = 0x12,
+	DCACHE_WRITETHROUGH = 0x1a,
+	DCACHE_WRITEBACK = 0x1e,
+};
+
+/* Size of an MMU section */
+enum {
+	MMU_SECTION_SHIFT	= 20,
+	MMU_SECTION_SIZE	= 1 << MMU_SECTION_SHIFT,
+};
+
+/**
+ * Change the cache settings for a region.
+ *
+ * \param start		start address of memory region to change
+ * \param size		size of memory region to change
+ * \param option	dcache option to select
+ */
+void mmu_set_region_dcache_behaviour(u32 start, int size,
+				     enum dcache_option option);
+
+/**
+ * Register an update to the page tables, and flush the TLB
+ *
+ * \param start		start address of update in page table
+ * \param stop		stop address of update in page table
+ */
+void mmu_page_table_flush(unsigned long start, unsigned long stop);
+
 #endif /* __ASSEMBLY__ */
 
 #define arch_align_stack(x) (x)
diff '--exclude=.svn' -Naur u-boot-2011.06_original/arch/arm/include/asm/u-boot-arm.h u-boot-2011.06/arch/arm/include/asm/u-boot-arm.h
--- u-boot-2011.06_original/arch/arm/include/asm/u-boot-arm.h	2011-06-28 04:22:42.000000000 +0800
+++ u-boot-2011.06/arch/arm/include/asm/u-boot-arm.h	2014-07-29 17:28:38.819972000 +0800
@@ -72,6 +72,7 @@
 void	udelay_masked		(unsigned long usec);
 
 /* cpu/.../timer.c */
+unsigned long long usec_to_tick(unsigned long long usec);
 int	timer_init		(void);
 
 #endif	/* _U_BOOT_ARM_H_ */
diff '--exclude=.svn' -Naur u-boot-2011.06_original/arch/arm/include/asm/u-boot.h u-boot-2011.06/arch/arm/include/asm/u-boot.h
--- u-boot-2011.06_original/arch/arm/include/asm/u-boot.h	2011-06-28 04:22:42.000000000 +0800
+++ u-boot-2011.06/arch/arm/include/asm/u-boot.h	2014-07-29 17:28:38.819972000 +0800
@@ -39,6 +39,7 @@
 typedef struct bd_info {
     int			bi_baudrate;	/* serial console baudrate */
     unsigned long	bi_ip_addr;	/* IP Address */
+    unsigned char	bi_enetaddr[6]; /* Ethernet adress */
     ulong	        bi_arch_number;	/* unique id for this board */
     ulong	        bi_boot_params;	/* where this board expects params */
     struct				/* RAM configuration */
diff '--exclude=.svn' -Naur u-boot-2011.06_original/arch/arm/include/asm/utils.h u-boot-2011.06/arch/arm/include/asm/utils.h
--- u-boot-2011.06_original/arch/arm/include/asm/utils.h	1970-01-01 08:00:00.000000000 +0800
+++ u-boot-2011.06/arch/arm/include/asm/utils.h	2014-07-29 17:28:38.819972000 +0800
@@ -0,0 +1,40 @@
+/*
+ * (C) Copyright 2010
+ * Texas Instruments, <www.ti.com>
+ * Aneesh V <aneesh@ti.com>
+ *
+ * SPDX-License-Identifier:	GPL-2.0+
+ */
+#ifndef _UTILS_H_
+#define _UTILS_H_
+
+static inline s32 log_2_n_round_up(u32 n)
+{
+	s32 log2n = -1;
+	u32 temp = n;
+
+	while (temp) {
+		log2n++;
+		temp >>= 1;
+	}
+
+	if (n & (n - 1))
+		return log2n + 1; /* not power of 2 - round up */
+	else
+		return log2n; /* power of 2 */
+}
+
+static inline s32 log_2_n_round_down(u32 n)
+{
+	s32 log2n = -1;
+	u32 temp = n;
+
+	while (temp) {
+		log2n++;
+		temp >>= 1;
+	}
+
+	return log2n;
+}
+
+#endif
diff '--exclude=.svn' -Naur u-boot-2011.06_original/arch/arm/lib/board.c u-boot-2011.06/arch/arm/lib/board.c
--- u-boot-2011.06_original/arch/arm/lib/board.c	2011-06-28 04:22:42.000000000 +0800
+++ u-boot-2011.06/arch/arm/lib/board.c	2015-05-29 14:38:58.047483000 +0800
@@ -74,8 +74,7 @@
 #define CONFIG_IDENT_STRING ""
 #endif
 
-const char version_string[] =
-	U_BOOT_VERSION" (" U_BOOT_DATE " - " U_BOOT_TIME ")"CONFIG_IDENT_STRING;
+const char version_string[] = U_BOOT_VERSION" (" U_BOOT_DATE " - " U_BOOT_TIME ")"CONFIG_IDENT_STRING ;
 
 #ifdef CONFIG_DRIVER_RTL8019
 extern void rtl8019_get_enetaddr (uchar * addr);
@@ -111,6 +110,8 @@
 void inline __blue_LED_off(void) {}
 void blue_LED_off(void) __attribute__((weak, alias("__blue_LED_off")));
 
+extern void sec_env_relocate(void);
+
 /************************************************************************
  * Init Utilities							*
  ************************************************************************
@@ -137,6 +138,7 @@
 static int display_banner (void)
 {
 	printf ("\n\n%s\n\n", version_string);
+    printf ("Configured for target [%s]\n",TARGET_CONFIGURATION_NAME);
 	debug ("U-Boot code: %08lX -> %08lX  BSS: -> %08lX\n",
 	       _TEXT_BASE,
 	       _bss_start_ofs+_TEXT_BASE, _bss_end_ofs+_TEXT_BASE);
@@ -270,7 +272,7 @@
 	bd_t *bd;
 	init_fnc_t **init_fnc_ptr;
 	gd_t *id;
-	ulong addr, addr_sp;
+	ulong addr, addr_sp, addr_tmp;
 
 	/* Pointer is writable since we allocated a register for it */
 	gd = (gd_t *) ((CONFIG_SYS_INIT_SP_ADDR) & ~0x07);
@@ -352,6 +354,11 @@
 #endif /* CONFIG_LCD */
 
 	/*
+	  * reserve memory for hdmi PIC or dvu PIC code that will be combined after u-boot.bin
+	  */
+	addr -= CONFIG_UBOOT_EXTERNAL_PROC_LEN;
+
+	/*
 	 * reserve memory for U-Boot code, data & bss
 	 * round down to next 4 kB limit
 	 */
@@ -359,6 +366,11 @@
 	addr &= ~(4096 - 1);
 
 	debug ("Reserving %ldk for U-Boot at: %08lx\n", gd->mon_len >> 10, addr);
+	
+    /* Move the PIC codes behind the BSS segment */
+    addr_tmp=addr+gd->mon_len;
+    memcpy( (void*) addr_tmp , (void*) (_TEXT_BASE+_bss_end_ofs) , CONFIG_UBOOT_EXTERNAL_PROC_LEN );
+    debug ("\nUboot external codes at: %08lx\n",addr_tmp);
 
 #ifndef CONFIG_PRELOADER
 	/*
@@ -438,12 +450,16 @@
 void board_init_r (gd_t *id, ulong dest_addr)
 {
 	char *s;
-	bd_t *bd;
+	bd_t *bd=NULL;
 	ulong malloc_start;
 #if !defined(CONFIG_SYS_NO_FLASH)
 	ulong flash_size;
 #endif
+	bd=bd;
 
+#if defined(CONFIG_SPI_FLASH_CNC1800L) || defined(CONFIG_SPI_FLASH_CNC1900)
+    ulong size=0;
+#endif
 	gd = id;
 	bd = gd->bd;
 
@@ -451,6 +467,18 @@
 
 	monitor_flash_len = _end_ofs;
 	debug ("monitor flash len: %08lX\n", monitor_flash_len);
+#ifdef CONFIG_USE_IRQ
+    unsigned int cnt;
+    unsigned int *dest,*source;
+    dest=0;
+    source=(unsigned int *)dest_addr;
+    //printf("start vector copy,source=0x%X,dest=0x%X.\n",(unsigned int)source,(unsigned int)dest);
+    for(cnt=0;cnt<0x3c/4;cnt++)
+    {
+        *dest++=*source++;
+    }
+    //printf("%x,%x,%x,%x,%x,%x,%x,%x\n",*(unsigned int *)0,*(unsigned int *)4,*(unsigned int *)8,*(unsigned int *)12,*(unsigned int *)16,*(unsigned int *)20,*(unsigned int *)24,*(unsigned int *)28);
+#endif
 	board_init();	/* Setup chipselects */
 
 #ifdef CONFIG_SERIAL_MULTI
@@ -470,6 +498,18 @@
 	malloc_start = dest_addr - TOTAL_MALLOC_LEN;
 	mem_malloc_init (malloc_start, TOTAL_MALLOC_LEN);
 
+#if defined(CONFIG_SPI_FLASH_CNC1800L) || defined(CONFIG_SPI_FLASH_CNC1900)
+if (seeprom_probe() > 0) {
+		puts("Legacy SPI ");
+		size = gd->sf_inf->sector_size*gd->sf_inf->n_sectors;
+
+		if (gd->sf_size % 0x100000)
+			printf("Flash Size: %dKB\n", gd->sf_size/1024);
+		else
+			printf("Flash Size: %dMB\n", gd->sf_size/1024/1024);
+	}
+#endif
+
 #if !defined(CONFIG_SYS_NO_FLASH)
 	puts ("Flash: ");
 
@@ -518,6 +558,11 @@
 
 	/* initialize environment */
 	env_relocate ();
+#if defined(CONFIG_CMD_SEC_NVEDIT)
+    /* Initialize factory default environment. */
+    sec_env_relocate();
+#endif
+
 
 #if defined(CONFIG_CMD_PCI) || defined(CONFIG_PCI)
 	arm_pci_init();
diff '--exclude=.svn' -Naur u-boot-2011.06_original/arch/arm/lib/bootm.c u-boot-2011.06/arch/arm/lib/bootm.c
--- u-boot-2011.06_original/arch/arm/lib/bootm.c	2011-06-28 04:22:42.000000000 +0800
+++ u-boot-2011.06/arch/arm/lib/bootm.c	2014-07-29 17:28:38.819972000 +0800
@@ -31,6 +31,9 @@
 #include <fdt_support.h>
 
 DECLARE_GLOBAL_DATA_PTR;
+#undef debug
+#define debug printf
+
 
 #if defined (CONFIG_SETUP_MEMORY_TAGS) || \
     defined (CONFIG_CMDLINE_TAG) || \
@@ -146,6 +149,11 @@
 #ifdef CONFIG_INITRD_TAG
 	if (images->rd_start && images->rd_end)
 		setup_initrd_tag (bd, images->rd_start, images->rd_end);
+
+extern ulong ramdisk_start, ramdisk_end;
+
+	if (ramdisk_start && ramdisk_end)
+		setup_initrd_tag (bd, ramdisk_start, ramdisk_end);
 #endif
 	setup_end_tag(bd);
 #endif
diff '--exclude=.svn' -Naur u-boot-2011.06_original/arch/arm/lib/cache.c u-boot-2011.06/arch/arm/lib/cache.c
--- u-boot-2011.06_original/arch/arm/lib/cache.c	2011-06-28 04:22:42.000000000 +0800
+++ u-boot-2011.06/arch/arm/lib/cache.c	2014-07-29 17:28:38.819972000 +0800
@@ -2,32 +2,16 @@
  * (C) Copyright 2002
  * Wolfgang Denk, DENX Software Engineering, wd@denx.de.
  *
- * See file CREDITS for list of people who contributed to this
- * project.
- *
- * This program is free software; you can redistribute it and/or
- * modify it under the terms of the GNU General Public License as
- * published by the Free Software Foundation; either version 2 of
- * the License, or (at your option) any later version.
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston,
- * MA 02111-1307 USA
+ * SPDX-License-Identifier:	GPL-2.0+
  */
 
 /* for now: just dummy functions to satisfy the linker */
 
 #include <common.h>
 
-void  flush_cache (unsigned long dummy1, unsigned long dummy2)
+void  __flush_cache(unsigned long start, unsigned long size)
 {
-#if defined(CONFIG_OMAP2420) || defined(CONFIG_ARM1136)
+#if defined(CONFIG_ARM1136)
 	void arm1136_cache_flush(void);
 
 	arm1136_cache_flush();
@@ -38,10 +22,30 @@
 	/* disable write buffer as well (page 2-22) */
 	asm("mcr p15, 0, %0, c7, c10, 4" : : "r" (0));
 #endif
-#ifdef CONFIG_OMAP34XX
-	void v7_flush_cache_all(void);
-
-	v7_flush_cache_all();
-#endif
 	return;
 }
+void  flush_cache(unsigned long start, unsigned long size)
+	__attribute__((weak, alias("__flush_cache")));
+
+/*
+ * Default implementation:
+ * do a range flush for the entire range
+ */
+void	__flush_dcache_all(void)
+{
+	flush_cache(0, ~0);
+}
+void	flush_dcache_all(void)
+	__attribute__((weak, alias("__flush_dcache_all")));
+
+
+/*
+ * Default implementation of enable_caches()
+ * Real implementation should be in platform code
+ */
+void __enable_caches(void)
+{
+	puts("WARNING: Caches not enabled\n");
+}
+void enable_caches(void)
+	__attribute__((weak, alias("__enable_caches")));
diff '--exclude=.svn' -Naur u-boot-2011.06_original/arch/arm/lib/cache-cp15.c u-boot-2011.06/arch/arm/lib/cache-cp15.c
